// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/DirectEcho.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/direct_echo__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'first'
// Member 'first_filtered'
// Member 'second'
#include "off_highway_uss_msgs/msg/detail/echo__traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DirectEcho & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: first
  {
    out << "first: ";
    to_flow_style_yaml(msg.first, out);
    out << ", ";
  }

  // member: first_filtered
  {
    out << "first_filtered: ";
    to_flow_style_yaml(msg.first_filtered, out);
    out << ", ";
  }

  // member: second
  {
    out << "second: ";
    to_flow_style_yaml(msg.second, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DirectEcho & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: first
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "first:\n";
    to_block_style_yaml(msg.first, out, indentation + 2);
  }

  // member: first_filtered
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "first_filtered:\n";
    to_block_style_yaml(msg.first_filtered, out, indentation + 2);
  }

  // member: second
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "second:\n";
    to_block_style_yaml(msg.second, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DirectEcho & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::DirectEcho & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::DirectEcho & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::DirectEcho>()
{
  return "off_highway_uss_msgs::msg::DirectEcho";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::DirectEcho>()
{
  return "off_highway_uss_msgs/msg/DirectEcho";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::DirectEcho>
  : std::integral_constant<bool, has_fixed_size<off_highway_uss_msgs::msg::Echo>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::DirectEcho>
  : std::integral_constant<bool, has_bounded_size<off_highway_uss_msgs::msg::Echo>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_uss_msgs::msg::DirectEcho>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__TRAITS_HPP_
