// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_uss_msgs:msg/Echo.idl
// generated code does not contain a copyright notice
#include "off_highway_uss_msgs/msg/detail/echo__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
off_highway_uss_msgs__msg__Echo__init(off_highway_uss_msgs__msg__Echo * msg)
{
  if (!msg) {
    return false;
  }
  // amplitude
  // distance
  return true;
}

void
off_highway_uss_msgs__msg__Echo__fini(off_highway_uss_msgs__msg__Echo * msg)
{
  if (!msg) {
    return;
  }
  // amplitude
  // distance
}

bool
off_highway_uss_msgs__msg__Echo__are_equal(const off_highway_uss_msgs__msg__Echo * lhs, const off_highway_uss_msgs__msg__Echo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // amplitude
  if (lhs->amplitude != rhs->amplitude) {
    return false;
  }
  // distance
  if (lhs->distance != rhs->distance) {
    return false;
  }
  return true;
}

bool
off_highway_uss_msgs__msg__Echo__copy(
  const off_highway_uss_msgs__msg__Echo * input,
  off_highway_uss_msgs__msg__Echo * output)
{
  if (!input || !output) {
    return false;
  }
  // amplitude
  output->amplitude = input->amplitude;
  // distance
  output->distance = input->distance;
  return true;
}

off_highway_uss_msgs__msg__Echo *
off_highway_uss_msgs__msg__Echo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_uss_msgs__msg__Echo * msg = (off_highway_uss_msgs__msg__Echo *)allocator.allocate(sizeof(off_highway_uss_msgs__msg__Echo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_uss_msgs__msg__Echo));
  bool success = off_highway_uss_msgs__msg__Echo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_uss_msgs__msg__Echo__destroy(off_highway_uss_msgs__msg__Echo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_uss_msgs__msg__Echo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_uss_msgs__msg__Echo__Sequence__init(off_highway_uss_msgs__msg__Echo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_uss_msgs__msg__Echo * data = NULL;

  if (size) {
    data = (off_highway_uss_msgs__msg__Echo *)allocator.zero_allocate(size, sizeof(off_highway_uss_msgs__msg__Echo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_uss_msgs__msg__Echo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_uss_msgs__msg__Echo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_uss_msgs__msg__Echo__Sequence__fini(off_highway_uss_msgs__msg__Echo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_uss_msgs__msg__Echo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_uss_msgs__msg__Echo__Sequence *
off_highway_uss_msgs__msg__Echo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_uss_msgs__msg__Echo__Sequence * array = (off_highway_uss_msgs__msg__Echo__Sequence *)allocator.allocate(sizeof(off_highway_uss_msgs__msg__Echo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_uss_msgs__msg__Echo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_uss_msgs__msg__Echo__Sequence__destroy(off_highway_uss_msgs__msg__Echo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_uss_msgs__msg__Echo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_uss_msgs__msg__Echo__Sequence__are_equal(const off_highway_uss_msgs__msg__Echo__Sequence * lhs, const off_highway_uss_msgs__msg__Echo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_uss_msgs__msg__Echo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_uss_msgs__msg__Echo__Sequence__copy(
  const off_highway_uss_msgs__msg__Echo__Sequence * input,
  off_highway_uss_msgs__msg__Echo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_uss_msgs__msg__Echo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_uss_msgs__msg__Echo * data =
      (off_highway_uss_msgs__msg__Echo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_uss_msgs__msg__Echo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_uss_msgs__msg__Echo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_uss_msgs__msg__Echo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
