// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_uss_msgs:msg/Information.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_uss_msgs__msg__Information __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_uss_msgs__msg__Information __declspec(deprecated)
#endif

namespace off_highway_uss_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Information_
{
  using Type = Information_<ContainerAllocator>;

  explicit Information_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_sensors = 0;
      this->sending_pattern = 0;
      this->operating_mode = 0;
      this->outside_temperature = 0.0;
      this->sensor_blindness = 0;
      this->sensitivity = 0;
      this->sensor_faulted = 0;
      this->failure_status = false;
    }
  }

  explicit Information_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_sensors = 0;
      this->sending_pattern = 0;
      this->operating_mode = 0;
      this->outside_temperature = 0.0;
      this->sensor_blindness = 0;
      this->sensitivity = 0;
      this->sensor_faulted = 0;
      this->failure_status = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _number_sensors_type =
    uint8_t;
  _number_sensors_type number_sensors;
  using _sending_pattern_type =
    uint8_t;
  _sending_pattern_type sending_pattern;
  using _operating_mode_type =
    uint8_t;
  _operating_mode_type operating_mode;
  using _outside_temperature_type =
    double;
  _outside_temperature_type outside_temperature;
  using _sensor_blindness_type =
    uint16_t;
  _sensor_blindness_type sensor_blindness;
  using _sensitivity_type =
    uint8_t;
  _sensitivity_type sensitivity;
  using _sensor_faulted_type =
    uint16_t;
  _sensor_faulted_type sensor_faulted;
  using _failure_status_type =
    bool;
  _failure_status_type failure_status;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__number_sensors(
    const uint8_t & _arg)
  {
    this->number_sensors = _arg;
    return *this;
  }
  Type & set__sending_pattern(
    const uint8_t & _arg)
  {
    this->sending_pattern = _arg;
    return *this;
  }
  Type & set__operating_mode(
    const uint8_t & _arg)
  {
    this->operating_mode = _arg;
    return *this;
  }
  Type & set__outside_temperature(
    const double & _arg)
  {
    this->outside_temperature = _arg;
    return *this;
  }
  Type & set__sensor_blindness(
    const uint16_t & _arg)
  {
    this->sensor_blindness = _arg;
    return *this;
  }
  Type & set__sensitivity(
    const uint8_t & _arg)
  {
    this->sensitivity = _arg;
    return *this;
  }
  Type & set__sensor_faulted(
    const uint16_t & _arg)
  {
    this->sensor_faulted = _arg;
    return *this;
  }
  Type & set__failure_status(
    const bool & _arg)
  {
    this->failure_status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_uss_msgs::msg::Information_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_uss_msgs::msg::Information_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Information_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Information_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_uss_msgs__msg__Information
    std::shared_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_uss_msgs__msg__Information
    std::shared_ptr<off_highway_uss_msgs::msg::Information_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Information_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->number_sensors != other.number_sensors) {
      return false;
    }
    if (this->sending_pattern != other.sending_pattern) {
      return false;
    }
    if (this->operating_mode != other.operating_mode) {
      return false;
    }
    if (this->outside_temperature != other.outside_temperature) {
      return false;
    }
    if (this->sensor_blindness != other.sensor_blindness) {
      return false;
    }
    if (this->sensitivity != other.sensitivity) {
      return false;
    }
    if (this->sensor_faulted != other.sensor_faulted) {
      return false;
    }
    if (this->failure_status != other.failure_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const Information_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Information_

// alias to use template instance with default allocator
using Information =
  off_highway_uss_msgs::msg::Information_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_uss_msgs

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__STRUCT_HPP_
