// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/MaxDetectionRange.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__MAX_DETECTION_RANGE__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__MAX_DETECTION_RANGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/max_detection_range__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MaxDetectionRange & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: max_detection_ranges
  {
    if (msg.max_detection_ranges.size() == 0) {
      out << "max_detection_ranges: []";
    } else {
      out << "max_detection_ranges: [";
      size_t pending_items = msg.max_detection_ranges.size();
      for (auto item : msg.max_detection_ranges) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MaxDetectionRange & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: max_detection_ranges
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.max_detection_ranges.size() == 0) {
      out << "max_detection_ranges: []\n";
    } else {
      out << "max_detection_ranges:\n";
      for (auto item : msg.max_detection_ranges) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MaxDetectionRange & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::MaxDetectionRange & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::MaxDetectionRange & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::MaxDetectionRange>()
{
  return "off_highway_uss_msgs::msg::MaxDetectionRange";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::MaxDetectionRange>()
{
  return "off_highway_uss_msgs/msg/MaxDetectionRange";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::MaxDetectionRange>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::MaxDetectionRange>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_uss_msgs::msg::MaxDetectionRange>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__MAX_DETECTION_RANGE__TRAITS_HPP_
